diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketExplosion.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketExplosion.java
index 65b01f637..82915d09e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketExplosion.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketExplosion.java
@@ -2,6 +2,7 @@ package net.minecraft.core.net.packet;
 
 import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.world.pos.TilePos;
 
 import java.io.*;
 import java.util.*;
@@ -13,14 +14,14 @@ public class PacketExplosion extends Packet
     public double explosionY;
     public double explosionZ;
     public float explosionSize;
-    public Set<ChunkPosition> destroyedBlockPositions;
+    public Set<TilePos> destroyedBlockPositions;
     public boolean isCannonball;
 
     public PacketExplosion()
     {
     }
 
-    public PacketExplosion(double d, double d1, double d2, float f, Set<ChunkPosition> set, boolean isCannonball)
+    public PacketExplosion(double d, double d1, double d2, float f, Set<TilePos> set, boolean isCannonball)
     {
         explosionX = d;
         explosionY = d1;
@@ -47,7 +48,7 @@ public class PacketExplosion extends Packet
             int j1 = dis.readByte() + j;
             int k1 = dis.readByte() + k;
             int l1 = dis.readByte() + l;
-            destroyedBlockPositions.add(new ChunkPosition(j1, k1, l1));
+            destroyedBlockPositions.add(new TilePos(j1, k1, l1));
         }
         isCannonball = dis.readBoolean();
 
@@ -64,11 +65,11 @@ public class PacketExplosion extends Packet
         int i = (int)explosionX;
         int j = (int)explosionY;
         int k = (int)explosionZ;
-        for (ChunkPosition chunkPosition : destroyedBlockPositions)
+        for (TilePos pos : destroyedBlockPositions)
         {
-            dos.writeByte(chunkPosition.x - i);
-            dos.writeByte(chunkPosition.y - j);
-            dos.writeByte(chunkPosition.z - k);
+            dos.writeByte(pos.x - i);
+            dos.writeByte(pos.y - j);
+            dos.writeByte(pos.z - k);
         }
         dos.writeBoolean(isCannonball);
 
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java b/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
index 236a8860e..c194dd3f2 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
@@ -251,11 +251,11 @@ public class BoundingVolume
             }
         }
 
-        System.out.println("Before line simplification: " + lineCoords.size() / 6 + " lines");
+        //System.out.println("Before line simplification: " + lineCoords.size() / 6 + " lines");
 
         IntList mergedLineCoords = mergeLines(lineCoords);
 
-        System.out.println("After line simplification: " + mergedLineCoords.size() / 6 + " lines");
+        //System.out.println("After line simplification: " + mergedLineCoords.size() / 6 + " lines");
 
         FloatList floatLineCoords = new FloatArrayList();
         for (int i : mergedLineCoords)
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index 7a0caad5e..ed6faa107 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.IArmorWearing;
@@ -10,8 +11,8 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3d;
@@ -30,7 +31,7 @@ public class Explosion {
     public double explosionY;
     public double explosionZ;
     public float explosionSize;
-    public Set<ChunkPosition> destroyedBlockPositions;
+    public Set<TilePos> destroyedBlockPositions;
     public boolean destroyBlocks;
 
     public Explosion(@NotNull World world, @Nullable Entity exploder, double x, double y, double z, float explosionSize) {
@@ -53,27 +54,18 @@ public class Explosion {
         calculateBlocksToDestroy();
 
         damageEntities();
-
-        if (this.destroyBlocks && this.isFlaming) createFire();
     }
 
     public void addEffects(boolean particles) {
         if (!this.world.isClientSide) {
             this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.explosionX, this.explosionY, this.explosionZ, "random.explode", 4F, (1.0F + (this.world.rand.nextFloat() - this.world.rand.nextFloat()) * 0.2F) * 0.7F);
         }
-        List<ChunkPosition> arraylist = new ArrayList<>(this.destroyedBlockPositions);
-        for (int i = arraylist.size() - 1; i >= 0; i--) {
-            ChunkPosition chunkposition = arraylist.get(i);
-
-            int x = chunkposition.x;
-            int y = chunkposition.y;
-            int z = chunkposition.z;
-
-            TileEntity tileEntity = this.world.getTileEntity(x, y, z);
+        for (var pos : this.destroyedBlockPositions) {
+            TileEntity tileEntity = this.world.getTileEntity(pos);
             if (particles) {
-                double xPos = (double) x + this.world.rand.nextFloat();
-                double yPos = (double) y + this.world.rand.nextFloat();
-                double zPos = (double) z + this.world.rand.nextFloat();
+                double xPos = (double) pos.x + this.world.rand.nextFloat();
+                double yPos = (double) pos.y + this.world.rand.nextFloat();
+                double zPos = (double) pos.z + this.world.rand.nextFloat();
                 double d3 = xPos - this.explosionX;
                 double d4 = yPos - this.explosionY;
                 double d5 = zPos - this.explosionZ;
@@ -90,14 +82,16 @@ public class Explosion {
                 this.world.spawnParticle("smoke", xPos, yPos, zPos, d3, d4, d5, 0, false);
             }
             if (this.destroyBlocks) {
-                Block<?> block = this.world.getBlock(x, y, z);
-                if (block != null) {
-                    block.dropBlockWithCause(this.world, EnumDropCause.EXPLOSION, x, y, z, this.world.getBlockMetadata(x, y, z), tileEntity, null);
-                    this.world.setBlockWithNotify(x, y, z, 0);
-                    block.onBlockDestroyedByExplosion(this.world, x, y, z);
+                Block<?> block = this.world.getBlockType(pos);
+                if (block != Blocks.AIR) {
+                    block.dropWithCause(this.world, EnumDropCause.EXPLOSION, pos, this.world.getBlockData(pos), tileEntity, null);
+                    this.world.setBlockTypeNotify(pos, Blocks.AIR);
+                    block.onDestroyedByExplosion(this.world, pos);
                 }
             }
         }
+
+        if (!this.world.isClientSide && this.destroyBlocks && this.isFlaming) createFire();
     }
 
     protected void calculateBlocksToDestroy() {
@@ -117,27 +111,25 @@ public class Explosion {
                     d1 /= d3;
                     d2 /= d3;
                     float f1 = this.explosionSize * (0.7F + this.world.rand.nextFloat() * 0.6F);
-                    double d5 = this.explosionX;
-                    double d7 = this.explosionY;
-                    double d9 = this.explosionZ;
+                    double ex = this.explosionX;
+                    double ey = this.explosionY;
+                    double ez = this.explosionZ;
                     float f2 = 0.3F;
                     while (true) {
                         if (f1 <= 0.0F) {
                             continue label0;
                         }
-                        int j4 = MathHelper.floor(d5);
-                        int k4 = MathHelper.floor(d7);
-                        int l4 = MathHelper.floor(d9);
-                        int i5 = this.world.getBlockId(j4, k4, l4);
-                        if (i5 > 0) {
-                            f1 -= (Blocks.blocksList[i5].getBlastResistance(this.exploder) + 0.3F) * f2;
+                        var tilePos = new TilePos(MathHelper.floor(ex), MathHelper.floor(ey), MathHelper.floor(ez));
+                        var block = this.world.getBlockType(tilePos);
+                        if (block != Blocks.AIR) {
+                            f1 -= (block.getBlastResistance(this.exploder) + 0.3F) * f2;
                         }
                         if (f1 > 0.0F) {
-                            this.destroyedBlockPositions.add(new ChunkPosition(j4, k4, l4));
+                            this.destroyedBlockPositions.add(tilePos);
                         }
-                        d5 += d * (double) f2;
-                        d7 += d1 * (double) f2;
-                        d9 += d2 * (double) f2;
+                        ex += d * (double) f2;
+                        ey += d1 * (double) f2;
+                        ez += d2 * (double) f2;
                         f1 -= f2 * 0.75F;
                     }
                 }
@@ -183,16 +175,15 @@ public class Explosion {
     }
 
     protected void createFire() {
-        List<ChunkPosition> arraylist = new ArrayList<>(this.destroyedBlockPositions);
-        for (int l2 = arraylist.size() - 1; l2 >= 0; l2--) {
-            ChunkPosition chunkposition = arraylist.get(l2);
-
-            int x1 = chunkposition.x;
-            int y1 = chunkposition.y;
-            int z1 = chunkposition.z;
-
-            if (this.world.getBlockId(x1, y1, z1) == Blocks.AIR.id() && Blocks.solid[this.world.getBlockId(x1, y1 - 1, z1)] && this.explosionRNG.nextInt(3) == 0) {
-                this.world.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
+        TilePos queryPos = new TilePos();
+        for (var pos : this.destroyedBlockPositions) {
+            Block<?> below;
+            if (this.world.isAirBlock(pos) && (below = this.world.getBlockType(pos.down(queryPos))).isSolidRender() && this.explosionRNG.nextInt(3) == 0) {
+                if (below.hasTag(BlockTags.INFINITE_BURN_SULFURIC)) {
+                    this.world.setBlockTypeNotify(pos, Blocks.FIRE_SULFURIC);
+                } else {
+                    this.world.setBlockTypeNotify(pos, Blocks.FIRE);
+                }
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
index f69505d13..c0c8f9342 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.weather;
 
+import net.minecraft.core.block.BlockLogicLayerSnow;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.BiomeTags;
@@ -73,7 +74,7 @@ public abstract class Weather {
             if (world.getBlockBiome(x, y, z).hasTag(BiomeTags.HAS_SURFACE_SNOW)) {
                 if (blockId == Blocks.LAYER_SNOW.id()) {
                     final int meta = world.getBlockMetadata(x, y, z);
-                    if (meta != 0) {
+                    if (!BlockLogicLayerSnow.isPermanent(meta) && meta != 0) {
                         world.setBlockMetadata(x, y, z, meta - 1);
                         world.markBlockNeedsUpdate(x, y, z);
                     }
@@ -81,7 +82,9 @@ public abstract class Weather {
             } else {
                 if (blockId == Blocks.LAYER_SNOW.id()) {
                     final int meta = world.getBlockMetadata(x, y, z);
-                    if (meta != 0) {
+                    if (BlockLogicLayerSnow.isPermanent(meta)) {
+                        //do nothing, layer is permanent
+                    } else if (meta != 0) {
                         world.setBlockMetadata(x, y, z, meta - 1);
                         world.markBlockNeedsUpdate(x, y, z);
                     } else {
@@ -108,12 +111,14 @@ public abstract class Weather {
                 int blockIdBelow = chunk.getBlockID(x, y - 1, z);
 
                 if (world.getBlockBiome(chunk.pos.x * 16 + x, y, chunk.pos.z * 16 + z).hasTag(BiomeTags.HAS_SURFACE_SNOW)) {
-                    if (blockId == Blocks.LAYER_SNOW.id()) {
+                    if (blockId == Blocks.LAYER_SNOW.id() && !BlockLogicLayerSnow.isPermanent(chunk.getBlockMetadata(x, y, z))) {
                         chunk.setBlockMetadata(x, y, z, 0);
                     }
                 } else {
                     if (blockId == Blocks.LAYER_SNOW.id()) {
-                        chunk.setBlockID(x, y, z, 0);
+                        if (!BlockLogicLayerSnow.isPermanent(chunk.getBlockMetadata(x, y, z))) {
+                            chunk.setBlockID(x, y, z, 0);
+                        }
                     } else if (blockIdBelow == Blocks.ICE.id()) {
                         chunk.setBlockID(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
                     }
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
index 11bdbdeb3..b5b68bd73 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
@@ -137,9 +137,8 @@ options.borderlessFullscreen.unavailable=Not Available
 options.enableVbos=Enable VBOs
 options.discordRichPresence=Discord Rich Presence
 options.blockOutlineWidth=Outline Visibility
-options.colorCorrection=Color Correction
-options.colorCorrection.low=Low
-options.colorCorrection.high=High
+options.colorCorrectionOverworld=Overworld Color Correction
+options.colorCorrectionNether=Nether Color Correction
 options.sneakToggle=Toggle Sneaking
 options.tooltipStyle=Tooltip Style
 options.font=Font
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 676660862..130067434 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -32,6 +32,8 @@ import net.minecraft.core.net.packet.*;
 import net.minecraft.server.world.ServerPlayerController;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.SlotResult;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.World;
@@ -802,6 +804,18 @@ public class PlayerServer extends Player implements ContainerListener {
         playerNetServerHandler.teleportAndRotate(x, y, z, yaw, pitch);
     }
 
+    @Override
+    public void playSoundToSelf(SoundCategory category, double x, double y, double z, String soundPath, float volume, float pitch) {
+        if (soundPath == null || playerNetServerHandler == null) {
+            return;
+        }
+        int soundId = SoundTypes.getSoundId(soundPath);
+        if (soundId == -1) {
+            return;
+        }
+        playerNetServerHandler.sendPacket(new PacketPlaySoundDirect(soundId, category, x, y, z, volume, pitch));
+    }
+
     @Override
     public boolean deferVehicleBehavior() {
         return true;
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index bf4db129c..853bf1272 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -57,6 +57,9 @@ public class SmeltingGenerator {
 
         blastRecipe("log_to_scorched_log", "minecraft:logs", Blocks.BLOCK_ASH.getDefaultStack(), Blocks.LOG_SCORCHED.getDefaultStack());
 
+        blastRecipe("rubyglass_column_and_brimsand_to_rubyglass_crystal", Blocks.RUBYGLASS_COLUMN.getDefaultStack(), Blocks.BRIMSAND.getDefaultStack(), Blocks.RUBYGLASS_CRYSTAL.getDefaultStack());
+
+
         addOreConversions(BlockLogicOreCoal.variantMap, "minecraft:coal_ores");
         addOreConversions(BlockLogicOreIron.variantMap, "minecraft:iron_ores");
         addOreConversions(BlockLogicOreGold.variantMap, "minecraft:gold_ores");
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 4d7899c9d..cf27cb6f6 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1555,7 +1555,7 @@ class WorkbenchGenerator {
         // Misc additions
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.SLATE_POLISHED).create("polished_slate_slab", new ItemStack(Blocks.SLAB_SLATE_POLISHED, 6));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("PO", "OP").addInput('P', Items.AMMO_PEBBLE).addInput('O', Blocks.OBSIDIAN).create("pebbles_to_gloomstone", new ItemStack(Blocks.COBBLE_GLOOMSTONE, 2));
-        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape(" S ", "SAS", " S ").addInput('S', Items.SULFUR).addInput('A', Items.AMMO_ARROW).create("flaming_arrow", new ItemStack(Items.AMMO_ARROW_FLAMING, 4));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.SULFUR).addInput(Items.PAPER).addInput(Items.AMMO_ARROW).addInput(Items.SULFUR).create("flaming_arrow", new ItemStack(Items.AMMO_ARROW_FLAMING, 1));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Items.SULFUR).create("sulfur_block", new ItemStack(Blocks.SULFUR, 1));
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_SCORCHED).create("scorched_log_to_black_wooden_planks", new ItemStack(Blocks.PLANKS_OAK_PAINTED, 4, 15));
